/*==============================================================================


   Purpose:    low level routines for Pentiums/Linux


   Author:     Rudolf Berrendorf
               Marc Cremer, Maiko Wessel
               University of Applied Sciences Bonn-Rhein-Sieg
               Computer Science Department
               53754 Sankt Augustin
               rudolf.berrendorf@fh-bonn-rhein-sieg.de


   last mod:   22.11.2002


   DISCLAIMER

                  PCL - The Performance Counter Library


   Copyright (C) 2002
   University of Applied Sciences Bonn-Rhein-Sieg

   Copyright (C) 2000
   Forschungszentrum Juelich GmbH, Federal Republic of Germany.
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:

   Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

     - Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.

     - Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

     - Any publications that result from the use of this software shall
       reasonably refer to the Research Centre's development.

     - All advertising materials mentioning features or use of this software
       must display the following acknowledgement:

           This product includes software developed by Forschungszentrum
           Juelich GmbH, Federal Republic of Germany.

     - Forschungszentrum Juelich GmbH is not obligated to provide the user with
       any support, consulting, training or assistance of any kind with regard
       to the use, operation and performance of this software or to provide
       the user with any updates, revisions or new versions.


   THIS SOFTWARE IS PROVIDED BY FORSCHUNGSZENTRUM JUELICH GMBH "AS IS" AND ANY
   EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   DISCLAIMED. IN NO EVENT SHALL FORSCHUNGSZENTRUM JUELICH GMBH BE LIABLE FOR
   ANY SPECIAL, DIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
   RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
   CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
   CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.
  
==============================================================================*/

#if !defined(PCL_HW_DRIVER_DEFS_INCLUDED)
#define PCL_HW_DRIVER_DEFS_INCLUDED

#include "libperfctr.h"

#define PCL_MAX_COUNTER 19        /* max. 18 counters (on Pentium 4),
				     one elapsed cycle counter */
#define COUNTER_SIZE_32           /* less than 64 bit performance counters */


/* value stored in hw_descr->vendor to distinguish processors of different
   vendors */
#define VENDOR_UNKNOWN 0  /* unknown vendor */
#define VENDOR_INTEL   1  /* Intel */
#define VENDOR_AMD     2  /* AMD */


/* hardware state descriptor */
typedef struct HW_state_descr
{
  /* self */
  struct vperfctr *self;

  /* vendor (Intel or AMD) */
  int vendor;

  /* base value of cycle counter */
  unsigned long long clock_value;

} HW_state_descr;


#endif


/*============================================================================*
 *                             that's all folks                               *
 *============================================================================*/
